<!--
  -  Copyright 2020 Huawei Technologies Co., Ltd.
  -
  -  Licensed under the Apache License, Version 2.0 (the "License");
  -  you may not use this file except in compliance with the License.
  -  You may obtain a copy of the License at
  -
  -      http://www.apache.org/licenses/LICENSE-2.0
  -
  -  Unless required by applicable law or agreed to in writing, software
  -  distributed under the License is distributed on an "AS IS" BASIS,
  -  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -  See the License for the specific language governing permissions and
  -  limitations under the License.
  -->

<template>
  <div>
    <div class="pageTitle">
      <el-row>
        <div class="el-row-button-input">
          <label>
            {{ $t('nav.myapplication') }}
          </label>
          <label
            v-if="dialogVisible"
            style="color:gray"
          >
            / Create Resource Request
          </label>
          <el-button
            id="backEnvBtn"
            style="float:right;"
            type="primary"
            v-if="dialogVisible"
            @click="getBack"
          >
            <em class="el-icon-back" />
            Back
          </el-button>
          <el-button
            v-else
            id="batchDltBtn"
            style="float:right;"
            type="primary"
            @click="dialogVisible = true"
          >
            <em class="el-icon-edit" />
            {{ $t('nav.resapplicationbtn') }}
          </el-button>
        </div>
      </el-row>
    </div>
    <div
      class="userList"
      v-if="dialogVisible"
    >
      <ResRequest
        @cancelDialog="cancel"
      />
    </div>
    <div
      class="userList"
      v-else
    >
      <SearchResource
        :lab-item="true"
        :status-item="true"
        :applicant-item="true"
        @getSearchData="getResRequestList"
      />
      <div class="tableDiv">
        <el-row>
          <el-col
            :span="24"
            class="table"
          >
            <el-table
              v-loading="dataLoading"
              :data="currPageTableData"
              border
            >
              <el-table-column
                prop="ipAddress"
                :label="$t('env.ipAddress')"
              />
              <el-table-column
                prop="lab"
                :label="$t('env.lab')"
              />
              <el-table-column
                :label="$t('env.status')"
              >
                <template slot-scope="scope">
                  <span
                    :style="getStatusColor(scope.row.status)"
                  >
                    {{ $t(scope.row.status) }}
                  </span>
                </template>
              </el-table-column>
              <el-table-column
                prop="specifications"
                :label="$t('env.specifications')"
              />
              <el-table-column
                prop="specialResources"
                :label="$t('env.specialResources')"
              />
              <el-table-column
                prop="requestRemarks"
                :label="$t('env.requestRemarks')"
              />
              <el-table-column
                :label="$t('env.operation')"
                width="180"
              >
                <template slot-scope="scope">
                  <el-button
                    id="editUsrBtn"
                    type="text"
                    size="small"
                    disabled
                  >
                    {{ $t('env.details') }}
                  </el-button>
                  <el-button
                    id="dltUsrBtn"
                    @click="cancelRequest(scope.row)"
                    type="text"
                    size="small"
                    :disabled="scope.row.status != 'Waiting'"
                  >
                    {{ $t('env.cancelApplication') }}
                  </el-button>
                </template>
              </el-table-column>
            </el-table>
          </el-col>
        </el-row>
        <div class="pageBar">
          <Pagination
            :table-data="paginationData"
            @getCurrentPageData="getCurrentPageData"
          />
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import axios from 'axios'
import { BASE_URL } from '../../tools/constant.js'
import SearchResource from '../../components/SearchResource.vue'
import Pagination from '../../components/Pagination.vue'
import ResRequest from './ResRequest.vue'
export default {
  name: 'CommunityRequests',
  components: {
    SearchResource,
    ResRequest,
    Pagination
  },
  data () {
    return {
      dataLoading: true,
      dialogVisible: false,
      currentRowData: {},
      loading: false,
      dialogLoading: false,
      resourceRequestList: [],
      paginationData: [],
      currPageTableData: []
    }
  },
  mounted () {
    this.getResRequestList()
  },
  computed: {
  },
  methods: {
    getStatusColor (status) {
      let statusColor = {}
      switch (status) {
        case 'Waiting':
          statusColor = { 'color': '#eeae5a' }
          break
        case 'Rejected':
          statusColor = { 'color': '#e82003' }
          break
        case 'Assigned':
        case 'Approved':
          statusColor = { 'color': '#3fa981' }
          break
      }
      return statusColor
    },
    getBack () {
      this.dialogVisible = false
      this.getResRequestList()
    },
    getCurrentPageData (data) {
      this.currPageTableData = data
    },
    async cancelRequest (data) {
      let url = BASE_URL + '/deleteResourceRequest?id=' + data.id
      axios({
        method: 'DELETE',
        url: url,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.$parent.successMessage(this.$t('confirm.deleteResRequestSuccess'))
        this.getResRequestList()
      }, error => {
        if (error) {
          this.$parent.errorMessage(this.$t(error.response.data))
          this.cancel()
        }
      })
    },
    async getResRequestList (data) {
      if (!data) {
        data = {
          ipAddress: '',
          status: 'ALL',
          lab: 'ALL',
          requestedBy: ''
        }
      }
      let userId = sessionStorage.getItem('userId')
      let url = `${BASE_URL}/getResourceRequest?userId=${userId}&ipAddress=${data.ipAddress}&lab=${data.lab}&status=${data.status}&requestedBy=${data.requestedBy}`
      axios({
        method: 'GET',
        url: url,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.paginationData = res.data.resourceRequestData
        this.dataLoading = false
      }, error => {
        if (error) {
          this.$parent.errorMessage(this.$t(error.response.data))
          this.dataLoading = false
        }
      })
    },
    cancel (isRefresh) {
      if (isRefresh) {
        this.getResRequestList()
      }
      this.dialogVisible = false
    }
  }
}
</script>

<style lang='less' scoped>
.pageTitle {
  margin: 5% 2% 1% 2%;
  font-weight: bold;
}
.userList {
    margin: 0 2%;
    height: 100%;
    background: #fff;
    padding: 30px 0px;
  .tableDiv {
    width: 100%;
  }
  .el-row-button-input {
    margin-top: 10px;
    height:40px;
  }
  .table {
    margin-top: 15px;
  }
  .el-row-table {
    margin-top: 10px;
  }
  .shortdesc{
    overflow: hidden;
    text-overflow: ellipsis;
    display:-webkit-box;
    -webkit-box-orient:vertical;
    -webkit-line-clamp:2;
  }
}
</style>
